Imports System.Runtime.InteropServices
Imports System.ComponentModel

'Add-in Express Add-in Module
<GuidAttribute("42C92BDD-F5F1-4616-B8D2-4A5DE0BEA822"), ProgIdAttribute("ADX_Ol_Event_ItemSend_VB.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
 
    Friend WithEvents adxOutlookEvents As AddinExpress.MSO.ADXOutlookAppEvents
    Friend WithEvents AdxOlFormsManager1 As AddinExpress.OL.ADXOlFormsManager
    Friend WithEvents AdxOlFormsCollectionItem1 As AddinExpress.OL.ADXOlFormsCollectionItem
#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.adxOutlookEvents = New AddinExpress.MSO.ADXOutlookAppEvents(Me.components)
        Me.AdxOlFormsManager1 = New AddinExpress.OL.ADXOlFormsManager(Me.components)
        Me.AdxOlFormsCollectionItem1 = New AddinExpress.OL.ADXOlFormsCollectionItem(Me.components)
        '
        'adxOutlookEvents
        '
        '
        'AdxOlFormsManager1
        '
        Me.AdxOlFormsManager1.Items.Add(Me.AdxOlFormsCollectionItem1)
        Me.AdxOlFormsManager1.SetOwner(Me)
        '
        'AdxOlFormsCollectionItem1
        '
        Me.AdxOlFormsCollectionItem1.FormClassName = "ADX_Ol_Event_ItemSend_VB.ADXOlForm1"
        Me.AdxOlFormsCollectionItem1.InspectorItemTypes = AddinExpress.OL.ADXOlInspectorItemTypes.olMail
        Me.AdxOlFormsCollectionItem1.InspectorLayout = AddinExpress.OL.ADXOlInspectorLayout.RightSubpane
        '
        'AddinModule
        '
        Me.AddinName = "ADX_Ol_Event_ItemSend_VB"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public ReadOnly Property OutlookApp() As Outlook._Application
        Get
            Return CType(HostApplication, Outlook._Application)
        End Get
    End Property

    Private Sub adxOutlookEvents_InspectorActivate(ByVal sender As System.Object, ByVal inspector As System.Object, ByVal folderName As System.String) Handles adxOutlookEvents.InspectorActivate
        Dim mailItem As Outlook._MailItem = TryCast(TryCast(inspector, Outlook.Inspector).CurrentItem, Outlook._MailItem)
        If mailItem IsNot Nothing Then
            Try
                AdxOlFormsManager1.Items(0).Enabled = Not mailItem.Sent
            Finally
                Marshal.ReleaseComObject(mailItem)
            End Try
        End If
    End Sub

    Private Sub adxOutlookEvents_ItemSend(ByVal sender As System.Object, ByVal e As AddinExpress.MSO.ADXOlItemSendEventArgs) Handles adxOutlookEvents.ItemSend
        e.Cancel = False
        Dim mailItem As Outlook._MailItem = TryCast(e.Item, Outlook._MailItem)
        If mailItem IsNot Nothing Then
            Dim olForm As ADXOlForm1 = TryCast( _
                AdxOlFormsManager1.Items(0).GetCurrentForm( _
                    AddinExpress.OL.EmbeddedFormStates.Visible), ADXOlForm1)
            mailItem.Save()
            If Not mailItem.Sent Then
                If olForm.checkBoxAddRecipient.Checked Then
                    mailItem.Recipients.Add(olForm.textBoxAddRecipient.Text)
                End If
                If olForm.checkBoxModifySubject.Checked Then
                    mailItem.Subject = (mailItem.Subject & " ") + DateTime.Now.ToString()
                End If
                If olForm.checkBoxAddTextBody.Checked Then
                    DoAddTextBody(mailItem, olForm)
                End If
                If olForm.checkBoxAddAttachment.Checked Then
                    DoAddAttachment(mailItem, olForm)
                End If
                If olForm.checkBoxSaveMailItemFolder.Checked Then
                    DoSaveMailItemFolder(mailItem, olForm)
                End If
                If olForm.checkBoxSaveMailItemFile.Checked Then
                    DoSaveMailItemFile(mailItem, olForm)
                End If
                If olForm.checkBoxForbidSending.Checked Then
                    e.Cancel = True
                    System.Windows.Forms.MessageBox.Show("Action canceled!")
                End If
            End If
        End If
    End Sub

    Private Sub DoAddTextBody(ByVal mailItem As Outlook._MailItem, ByVal olForm As ADXOlForm1)
        Dim startIndex As Integer = mailItem.Body.Length
        mailItem.Body = mailItem.Body.Insert(startIndex, olForm.textBoxAddTextBody.Text)
    End Sub

    Private Sub DoAddAttachment(ByVal mailItem As Outlook._MailItem, ByVal olForm As ADXOlForm1)
        Dim pathFileOpen As String = olForm.textBoxAddAttachment.Text
        mailItem.Attachments.Add(pathFileOpen, Outlook.OlAttachmentType.olByValue, Type.Missing, Type.Missing)
    End Sub

    Private Sub DoSaveMailItemFolder(ByVal mailItem As Outlook._MailItem, ByVal olForm As ADXOlForm1)
        If olForm.folder IsNot Nothing Then
            Try
                Dim copiedMailItem As Outlook._MailItem = TryCast(mailItem.Copy(), Outlook._MailItem)
                If copiedMailItem IsNot Nothing Then
                    Try
                        Dim fld As Outlook.MAPIFolder = TryCast(copiedMailItem.Parent, Outlook.MAPIFolder)
                        If olForm.folder.EntryID = fld.EntryID Then
                            copiedMailItem.Save()
                        Else
                            copiedMailItem.Move(olForm.folder)
                        End If
                    Finally
                        Marshal.ReleaseComObject(copiedMailItem)
                    End Try
                End If
            Finally
                Marshal.ReleaseComObject(olForm.folder)
            End Try
        End If
    End Sub

    Private Sub DoSaveMailItemFile(ByVal mailItem As Outlook._MailItem, ByVal olForm As ADXOlForm1)
        Dim pathFileSave As String = olForm.textBoxSaveMailItemFile.Text
        mailItem.SaveAs(pathFileSave, Outlook.OlSaveAsType.olMSG)
    End Sub
End Class

